#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "ldl_circular_com_cabeca.h"
using namespace std;

void mataLista(LISTA* l) {
   while(!vazia(l)) {
      removePrimeiro(l);
	}

	free(l->cabeca);
}

void inicializaListaLigada(LISTA* l) {
   l->cabeca = criaNo(-1);
   l->cabeca->prox = l->cabeca;
   l->cabeca->ant = l->cabeca;
}

bool vazia(LISTA* l) {
   return l->cabeca->prox == l->cabeca;
}

void exibeLista(LISTA* l) {
	for (NO* no = l->cabeca->prox; no != l->cabeca; no = no->prox) {
		cout << no->elem << " ";
	}

	cout << endl;
}

NO* criaNo(int elem) {
   NO* no = (NO*) malloc (sizeof(NO));
   no->prox = NULL;
   no->ant = NULL;

   no->elem = elem;
   return no;
}

void set_prox_ant(NO* a, NO* b) {
   a->prox = b;
   b->ant = a;
}


void insereNoInicio(LISTA *l, int elem) {
   NO* no = criaNo(elem);
   no->prox = l->cabeca->prox;
   l->cabeca->prox->ant = no;
   l->cabeca->prox = no;
   no->ant = l->cabeca;
}

void insereNoFim(LISTA* l, int elem) {
   NO* no = criaNo(elem);
   l->cabeca->ant->prox = no;
   no->ant = l->cabeca->ant;
   no->prox = l->cabeca;
   l->cabeca->ant = no;
}

int removePrimeiro(LISTA* l) {
	assert(!vazia(l));
	NO* aux = l->cabeca->prox;
	int elem = aux->elem;
	l->cabeca->prox = aux->prox;
   aux->prox->ant = l->cabeca;
	free(aux);
	return elem;
}

int removeUltimo(LISTA* l) {
   assert(!vazia(l));
   NO* aux = l->cabeca->ant;
   int elem = aux->elem;
   l->cabeca->ant = aux->ant;
   aux->ant->prox = l->cabeca;
   free(aux);
   return elem;
}



LISTA* interseccao(LISTA* l, LISTA* h) {
   LISTA* a = (LISTA*) malloc(sizeof(LISTA));
   inicializaListaLigada(a);
   NO* i = l->cabeca->prox;
   NO* j = h->cabeca->prox;

   while(i != l->cabeca && j != h->cabeca) {
      if(i->elem == j->elem) {
         insereNoFim(a, i->elem);
         i = i->prox;
         j = j->prox;
      } else if(i->elem > j->elem) {
         j = j->prox;
      } else if(i->elem < j->elem) {
         i = i->prox;
      }
   }

   return a;
}

int main() {
	LISTA l;
	inicializaListaLigada(&l);

   LISTA a;
   LISTA b;
   inicializaListaLigada(&a);
   inicializaListaLigada(&b);

   insereNoFim(&a, 2);
   insereNoFim(&a, 4);
   insereNoFim(&a, 8);
   insereNoFim(&a, 15);

   insereNoFim(&b, 1);
   insereNoFim(&b, 2);
   insereNoFim(&b, 5);
   insereNoFim(&b, 8);
   insereNoFim(&b, 10);

   LISTA* c = interseccao(&a, &b);

   exibeLista(c);
   return 0;

/*
	while(true) {
		int elem;
		char cmd;
		cin >> cmd;

      if(cmd != 'r' && cmd != 'h') {
         cin >> elem;
      }

		if(cmd == 'i') {
			cout << "insere " << elem << endl;
			insereNoInicio(&l, elem);
		} else if(cmd == 'f') {
			cout << "insere no fim " << elem << endl;
			insereNoFim(&l, elem);
      } else if(cmd == 'r') {
         cout << "remove ultimo " << elem << endl;
         removeUltimo(&l);
      } else if(cmd == 'h') {
			cout << "remove primeiro " << elem << endl;
			removePrimeiro(&l);
		} else {
			cout << "comando invalido" << endl;
		}

		cout << "exibe lista: " << ends;
		exibeLista(&l);
	}

	return 0;
   */
}
