#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "ldl_circular_com_cabeca.h"
using namespace std;

void mataLista(LISTA* l) {
   while(!vazia(l)) {
      removePrimeiro(l);
	}

	free(l->cabeca);
}

void inicializaListaLigada(LISTA* l) {
   l->cabeca = criaNo(-1);
   l->cabeca->prox = l->cabeca;
   l->cabeca->ant = l->cabeca;
}

bool vazia(LISTA* l) {
   return l->cabeca->prox == l->cabeca;
}

void exibeLista(LISTA* l) {
	for (NO* no = l->cabeca->prox; no != l->cabeca; no = no->prox) {
		cout << no->elem << " ";
	}

	cout << endl;
}

NO* criaNo(int elem) {
   NO* no = (NO*) malloc (sizeof(NO));
   no->prox = NULL;
   no->ant = NULL;

   no->elem = elem;
   return no;
}

void set_prox_ant(NO* a, NO* b) {
   a->prox = b;
   b->ant = a;
}


void insereNoInicio(LISTA *l, int elem) {
   NO* no = criaNo(elem);
   set_prox_ant(no, l->cabeca->prox);
   set_prox_ant(no->cabeca, no);
}

void insereNoFim(LISTA* l, int elem) {
   NO* no = criaNo(elem);
   set_prox_ant(l->cabeca->ant, no);
   set_prox_ant(no, l->cabeca);
}

int removePrimeiro(LISTA* l) {
	assert(!vazia(l));
	NO* aux = l->cabeca->prox;
	int elem = aux->elem;
	set_prox_ant(l->cabeca, aux->prox);
	free(aux);
	return elem;
}

int removeUltimo(LISTA* l) {
   assert(!vazia(l));
   NO* aux = l->cabeca->ant;
   int elem = aux->elem;
   set_prox_ant(aux->ant, l->cabeca);
   free(aux);
   return elem;
}

int main() {
	LISTA l;
	inicializaListaLigada(&l);

	while(true) {
		int elem;
		char cmd;
		cin >> cmd;

      if(cmd != 'r' && cmd != 'h') {
         cin >> elem;
      }

		if(cmd == 'i') {
			cout << "insere " << elem << endl;
			insereNoInicio(&l, elem);
		} else if(cmd == 'f') {
			cout << "insere no fim " << elem << endl;
			insereNoFim(&l, elem);
      } else if(cmd == 'r') {
         cout << "remove ultimo " << endl;
         removeUltimo(&l);
      } else if(cmd == 'h') {
			cout << "remove primeiro " << endl;
			removePrimeiro(&l);
		} else {
			cout << "comando invalido" << endl;
		}

		cout << "exibe lista: " << ends;
		exibeLista(&l);
	}

	return 0;
}
