#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "ll_circular_com_cabeca.h"
using namespace std;

void mataLista(LISTA* l) {
   while(!vazia(l)) {
      removePrimeiro(l);
	}

	free(l->cabeca);
}

void inicializaListaLigada(LISTA* l) {
   l->cabeca = criaNo(-1);
   l->cabeca->prox = l->cabeca;
}

bool vazia(LISTA* l) {
   return l->cabeca->prox == l->cabeca;
}

void exibeLista(LISTA* l) {
	for (NO* no = l->cabeca->prox; no != l->cabeca; no = no->prox) {
		cout << no->elem << " ";
	}

	cout << endl;
}

NO* criaNo(int elem) {
   NO* no = (NO*) malloc (sizeof(NO));
   no->prox = NULL;

   no->elem = elem;
   return no;
}


void insereNoInicio(LISTA *l, int elem) {
   NO* no = criaNo(elem);
   no->prox = l->cabeca->prox;
   l->cabeca->prox = no;
}

void insereNoFim(LISTA* l, int elem) {
   NO* no = criaNo(-1);
   no->prox = l->cabeca->prox;
   l->cabeca->prox = no;
   l->cabeca->elem = elem;
   l->cabeca = no;
}

int removePrimeiro(LISTA* l) {
	assert(!vazia(l));
	NO* aux = l->cabeca->prox;
	int elem = aux->elem;
	l->cabeca->prox = l->cabeca->prox->prox;
	free(aux);
	return elem;
}

int main() {
	LISTA l;
	inicializaListaLigada(&l);

	while(true) {
		int elem;
		char cmd;
		cin >> cmd;
	   cin >> elem;

		if(cmd == 'i') {
			cout << "insere " << elem << endl;
			insereNoInicio(&l, elem);
		} else if(cmd == 'f') {
			cout << "insere no fim " << elem << endl;
			insereNoFim(&l, elem);
		} else {
			cout << "comando invalido" << endl;
		}

		cout << "exibe lista: " << ends;
		exibeLista(&l);
	}

	return 0;
}
